#line 1 "c:/users/Zsolt/temp/RelayTimerV4_mikroC_Software/PIC16F628A_Relay_Timer.c"







sbit LCD_RS at RB5_bit;
sbit LCD_EN at RB4_bit;
sbit LCD_D7 at RB0_bit;
sbit LCD_D6 at RB1_bit;
sbit LCD_D5 at RB2_bit;
sbit LCD_D4 at RB3_bit;
sbit LCD_RS_Direction at TRISB5_bit;
sbit LCD_EN_Direction at TRISB4_bit;
sbit LCD_D7_Direction at TRISB0_bit;
sbit LCD_D6_Direction at TRISB1_bit;
sbit LCD_D5_Direction at TRISB2_bit;
sbit LCD_D4_Direction at TRISB3_bit;


sbit SND at RB6_bit;



sbit LED at RA4_bit;
sbit OUT at RB7_bit;


int cnt, OneSecond, tmp;
short minutes, seconds;
bit start, oldF1;
char str1[6];






void buzzer(unsigned int duration) {
 unsigned int n;
 n = (duration << 1) + (duration >> 1);
 while (n) {
 SND = 1;
 Delay_us(206);
 SND = 0;
 Delay_us(206);
 n--;
 }
}




void interrupt() {
 cnt++;
 if (cnt > OneSecond) {
 cnt = 0;
 if (start) {
 if (seconds > 0) seconds--;
 else {
 if (minutes > 0) {
 seconds = 59;
 minutes--;
 }
 else {
 LED = 0;
 OUT = 0;
 start = 0;
 buzzer(500);
 Delay_ms(100);
 buzzer(500);
 Delay_ms(100);
 buzzer(500);
 Delay_ms(100);
 buzzer(1000);
 }
 }
 }
 }
 INTCON.T0IF = 0;
}


void main() {

 CMCON = 0b11111111;
 OPTION_REG = 0b11010001;
 INTCON = 0b10100000;
 TMR0 = 0;
 TRISA = 0b11101111;
 TRISB = 0b00000000;
 LED = 1;
 OUT = 0;


 seconds = 0;
 minutes = 0;
 start = 0;
 cnt = 0;
 oldF1 = 0;
 str1[4] = ' ';
 str1[5] = 0;








 OneSecond =  977 ;
 if (EEPROM_Read(0x00) == 1) {
 Delay_ms(30);
  ((char *)&OneSecond)[0]  = EEPROM_Read(0x01);
 Delay_ms(30);
  ((char *)&OneSecond)[1]  = EEPROM_Read(0x02);
 }
 Delay_ms(30);


 Lcd_Init();
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Cmd(_LCD_CURSOR_OFF);
 Delay_ms(100);
 Lcd_Out(1,1,"DIYfan.");
 Lcd_Out(2,1,"blogspot.com");
 Delay_ms(2000);
 Lcd_Cmd(_LCD_CLEAR);
 Delay_ms(100);

 while(1) {





 while (!PORTA.F0) {
 tmp = OneSecond;
 str1[3] = tmp%10 + '0';
 tmp = tmp/10;
 str1[2] = tmp%10 + '0';
 tmp = tmp/10;
 str1[1] = tmp%10 + '0';
 tmp = tmp/10;
 str1[0] = tmp%10 + '0';
 Lcd_Out(1,1,str1);
 if (!PORTA.F1) {
 EEPROM_Write(0x00, 0xFF);
 OneSecond =  977 ;
 Delay_ms(30);
 }
 if (!PORTA.F2) {
 OneSecond++;
 EEPROM_Write(0x00, 1);
 Delay_ms(50);
 EEPROM_Write(0x01,  ((char *)&OneSecond)[0] );
 Delay_ms(50);
 EEPROM_Write(0x02,  ((char *)&OneSecond)[1] );
 Delay_ms(50);
 }
 if (!PORTA.F3) {
 OneSecond--;
 EEPROM_Write(0x00, 1);
 Delay_ms(50);
 EEPROM_Write(0x01,  ((char *)&OneSecond)[0] );
 Delay_ms(50);
 EEPROM_Write(0x02,  ((char *)&OneSecond)[1] );
 Delay_ms(50);
 }
 }

 if (PORTA.F1 != oldF1) {
 if (oldF1) {
 if (!start && !seconds && !minutes)
 LED = 1;
 else {
 start = !start;
 OUT = start;
 if (start) {
 LED = 1;
 cnt = 0;
 }
 }
 }
 oldF1 = PORTA.F1;
 Delay_ms(100);
 }


 if (!PORTA.F2 && !PORTA.F3) {
 start = 0;
 minutes = 0;
 seconds = 0;
 LED = 1;
 OUT = 0;
 Delay_ms(100);
 }
 else
 if (!start) {
 if (!PORTA.F3) {
 LED = 1;
 if (seconds < 59)
 seconds++;
 else
 seconds = 0;
 Delay_ms(100);
 }
 if (!PORTA.F2) {
 LED = 1;
 if (minutes < 99)
 minutes++;
 else
 minutes = 0;
 Delay_ms(100);
 }
 }


 if (start)
 Lcd_Out(1, 1, "Time left:    ");
 else {
 if (!LED) {
 Lcd_Out(1, 1, "Finished!     ");
 }
 else {
 Lcd_Out(1, 1, "Adjusting time");
 }
 }
 Lcd_Chr(2, 1, minutes/10 + '0');
 Lcd_Chr_CP(minutes%10 + '0');
 Lcd_Chr_CP(':');
 Lcd_Chr_CP(seconds/10 + '0');
 Lcd_Chr_CP(seconds%10 + '0');
 Delay_ms(100);
 }
}
